#!/bin/sh

if [[ $LANG = *"en"* ]]; then
export NOTICE="DONE"
export BUILD="Compile"
export INSTALL="Install"
export TEXT="Configure Anbox"
export DOWNLOAD="Download"

elif [[ $LANG = *"es"* ]]; then
export NOTICE="HECHO"
export BUILD="Compilar"
export TEXT="Configurar Anbox"
export INSTALL="Instalar"
export DOWNLOAD="Descargar"

elif [[ $LANG = *"fr"* ]]; then
export NOTICE="DONE"
export BUILD="Compiler"
export TEXT="Configurer Anbox"
export INSTALL="Installer"
export DOWNLOAD="Télécharger"

elif [[ $LANG = *"hi"* ]]; then
export NOTICE="किया"
export BUILD="समेकित"
export TEXT="Anbox कॉन्फ़िगर है"
export INSTALL="इंस्टॉल करें"
export DOWNLOAD="डाउनलोड"

elif [[ $LANG = *"ar"* ]]; then
export NOTICE="انتهت المهمة"
export BUILD="تجميع"
export TEXT="Anbox تكوين"
export INSTALL="التثبت"
export DOWNLOAD="تحميل"

elif [[ $LANG = *"pt"* ]]; then
export NOTICE="COMPLETO"
export BUILD="Compilar"
export TEXT="Configurar Anbox"
export INSTALL="Instalar"
export DOWNLOAD="Baixar"

elif [[ $LANG = *"de"* ]]; then
export NOTICE="Vollständig"
export BUILD="Übersetzen"
export TEXT="Anbox konfigurieren"
export INSTALL="Installieren"
export DOWNLOAD="Herunterladen"

elif [[ $LANG = *"it"* ]]; then
export NOTICE="COMPLETARE"
export BUILD="Compilare"
export TEXT="Configurare Anbox"
export INSTALL="Installare"
export DOWNLOAD="Scaricare"

elif [[ $LANG = *"zh"* ]]; then
export NOTICE="在任务完成后"
export BUILD="编译程序"
export TEXT="Anbox 配置。"
export INSTALL="安装"
export DOWNLOAD="下载"

else
export NOTICE="DONE"
export BUILD="Compile"
export INSTALL="Install"
export TEXT="Configure Anbox"
export DOWNLOAD="Download"
fi

XTERM(){

killall anbox
yay -S anbox-modules-dkms-git --noconfirm --force
yay -S anbox-git --noconfirm --force
sudo pacman -S anbox-image --noconfirm --force
sudo pacman -S snap wget lzip unzip squashfs-tools --noconfirm --needed
sudo snap install --devmode --beta anbox
sudo modprobe ashmem_linux
sudo modprobe binder_linux
sudo systemctl start systemd-resolved.service
sudo systemctl enable systemd-resolved.service
sudo systemctl start systemd-networkd.service
sudo systemctl enable systemd-networkd.service
sudo systemctl start anbox-container-manager.service
sudo systemctl enable anbox-container-manager.service
systemctl --user start anbox-session-manager.service
systemctl --user enable anbox-session-manager.service
sudo sed -i "5s|.*|ExecStart=/usr/bin/anbox session-manager --gles-driver=host|" /usr/lib/systemd/user/anbox-session-manager.service
sudo systemctl daemon-reload
systemctl --user daemon-reload
sudo systemctl --user start anbox-session-manager.service
sudo systemctl --user enable anbox-session-manager.service
sudo install-playstore.sh
sudo mkdir /usr/lib/anbox
sudo rm -f ./anbox-bridge.sh
wget https://github.com/anbox/anbox/raw/master/scripts/anbox-bridge.sh
sudo mv -f ./anbox-bridge.sh /usr/lib/anbox/
chmod +x /usr/lib/anbox/anbox-bridge.sh
sudo rm -f ./anbox-bridge.c
wget https://gitlab.com/RebornOS/anbox-reborn/raw/master/anbox-bridge.c
sudo rm -f ./anbox-bridge
gcc -o anbox-bridge anbox-bridge.c
sudo mv -f ./anbox-bridge /usr/local/bin/
chmod u+s /usr/local/bin/anbox-bridge
sudo /usr/local/bin/anbox-bridge start
sudo systemctl stop anbox-container-manager.service
systemctl --user stop anbox-session-manager.service
sudo systemctl stop systemd-resolved.service
sudo systemctl stop systemd-networkd.service
sudo systemctl restart anbox-container-manager.service
systemctl --user restart anbox-session-manager.service
sudo systemctl restart systemd-resolved.service
sudo systemctl restart systemd-networkd.service

}

PLAYSTORE(){
OPENGAPPS_RELEASEDATE="20180706"
OPENGAPPS_FILE="open_gapps-x86_64-7.1-mini-$OPENGAPPS_RELEASEDATE.zip"
OPENGAPPS_URL="https://github.com/opengapps/x86_64/releases/download/$OPENGAPPS_RELEASEDATE/$OPENGAPPS_FILE"

HOUDINI_URL="http://dl.android-x86.org/houdini/7_y/houdini.sfs"
HOUDINI_SO="https://github.com/Rprop/libhoudini/raw/master/4.0.8.45720/system/lib/libhoudini.so"

WORKDIR="$(pwd)/anbox-work"

# check if script was started with BASH
if [ ! "$(ps -p $$ -oargs= | awk '{print $1}' | grep -E 'bash$')" ]; then
   echo "Please use BASH to start the script!"
	 exit 1
fi

# check if user is root
if [ "$(whoami)" != "root" ]; then
	echo "Sorry, you are not root. Please run with sudo $0"
	exit 1
fi

# check if lzip is installed
if [ ! "$(which lzip)" ]; then
	echo -e "lzip is not installed. Please install lzip.\nExample: sudo apt install 
lzip"
	exit 1
fi

# check if squashfs-tools are installed
if [ ! "$(which mksquashfs)" ] || [ ! "$(which unsquashfs)" ]; then
	echo -e "squashfs-tools is not installed. Please install 
squashfs-tools.\nExample: sudo apt install squashfs-tools"
	exit 1
else
	MKSQUASHFS=$(which mksquashfs)
	UNSQUASHFS=$(which unsquashfs)
fi

# check if wget is installed
if [ ! "$(which wget)" ]; then
	echo -e "wget is not installed. Please install wget.\nExample: sudo apt install 
wget"
	exit 1
else
	WGET=$(which wget)
fi

# check if unzip is installed
if [ ! "$(which unzip)" ]; then
	echo -e "unzip is not installed. Please install unzip.\nExample: sudo apt install 
unzip"
	exit 1
else
	UNZIP=$(which unzip)
fi

# check if tar is installed
if [ ! "$(which tar)" ]; then
	echo -e "tar is not installed. Please install tar.\nExample: sudo apt install 
tar"
	exit 1
else
	TAR=$(which tar)
fi

# use sudo if installed
if [ ! "$(which sudo)" ]; then
	SUDO=""
else
	SUDO=$(which sudo)
fi

echo $WORKDIR
if [ ! -d "$WORKDIR" ]; then
    mkdir "$WORKDIR"
fi

cd "$WORKDIR"

if [ -d "$WORKDIR/squashfs-root" ]; then
  $SUDO rm -rf squashfs-root
fi

# get image from anbox
cp /var/lib/anbox/android.img .
$SUDO $UNSQUASHFS android.img

# get opengapps and install it
cd "$WORKDIR"
if [ ! -f ./$OPENGAPPS_FILE ]; then
  $WGET -q --show-progress $OPENGAPPS_URL
  $UNZIP -d opengapps ./$OPENGAPPS_FILE
fi


cd ./opengapps/Core/
for filename in *.tar.lz
do
    $TAR --lzip -xvf ./$filename
done

cd "$WORKDIR"

$SUDO cp -r ./$(find opengapps -type d -name "PrebuiltGmsCore") ./squashfs-root/system/priv-app/
$SUDO cp -r ./$(find opengapps -type d -name "GoogleLoginService") ./squashfs-root/system/priv-app/
$SUDO cp -r ./$(find opengapps -type d -name "Phonesky") ./squashfs-root/system/priv-app/
$SUDO cp -r ./$(find opengapps -type d -name "GoogleServicesFramework") ./squashfs-root/system/priv-app/

cd ./squashfs-root/system/priv-app/
$SUDO chown -R 100000:100000 Phonesky GoogleLoginService GoogleServicesFramework PrebuiltGmsCore

# load houdini and spread it
cd "$WORKDIR"
if [ ! -f ./houdini.sfs ]; then
  $WGET -q --show-progress $HOUDINI_URL
  mkdir -p houdini
  $SUDO $UNSQUASHFS -f -d ./houdini ./houdini.sfs
fi

$SUDO cp -r ./houdini/houdini ./squashfs-root/system/bin/

$SUDO cp -r ./houdini/xstdata ./squashfs-root/system/bin/
$SUDO chown -R 100000:100000 ./squashfs-root/system/bin/houdini ./squashfs-root/system/bin/xstdata

$SUDO $WGET -q --show-progress -P ./squashfs-root/system/lib/ $HOUDINI_SO
$SUDO chown -R 100000:100000 ./squashfs-root/system/lib/libhoudini.so

$SUDO mkdir -p ./squashfs-root/system/lib/arm
$SUDO cp -r ./houdini/linker ./squashfs-root/system/lib/arm
$SUDO cp -r ./houdini/*.so ./squashfs-root/system/lib/arm
$SUDO cp -r ./houdini/nb ./squashfs-root/system/lib/arm/

$SUDO chown -R 100000:100000 ./squashfs-root/system/lib/arm

# add houdini parser
mkdir -p ./squashfs-root/system/etc/binfmt_misc
echo ":arm_dyn:M::\x7f\x45\x4c\x46\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x00\x28::/system/bin/houdini:" >> ./squashfs-root/system/etc/binfmt_misc/arm_dyn
echo ":arm_exe:M::\x7f\x45\x4c\x46\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28::/system/bin/houdini:" >> ./squashfs-root/system/etc/binfmt_misc/arm_exe
$SUDO chown -R 100000:100000 ./squashfs-root/system/etc/binfmt_misc

# add features
C=$(cat <<-END
  <feature name="android.hardware.touchscreen" />\n
  <feature name="android.hardware.audio.output" />\n
  <feature name="android.hardware.camera" />\n
  <feature name="android.hardware.camera.any" />\n
  <feature name="android.hardware.location" />\n
  <feature name="android.hardware.location.gps" />\n
  <feature name="android.hardware.location.network" />\n
  <feature name="android.hardware.microphone" />\n
  <feature name="android.hardware.screen.portrait" />\n
  <feature name="android.hardware.screen.landscape" />\n
  <feature name="android.hardware.wifi" />\n
  <feature name="android.hardware.bluetooth" />"
END
)


C=$(echo $C | sed 's/\//\\\//g')
C=$(echo $C | sed 's/\"/\\\"/g')
$SUDO sed -i "/<\/permissions>/ s/.*/${C}\n&/" ./squashfs-root/system/etc/permissions/anbox.xml

# make wifi and bt available
$SUDO sed -i "/<unavailable-feature name=\"android.hardware.wifi\" \/>/d" ./squashfs-root/system/etc/permissions/anbox.xml
$SUDO sed -i "/<unavailable-feature name=\"android.hardware.bluetooth\" \/>/d" ./squashfs-root/system/etc/permissions/anbox.xml

# set processors
ARM_TYPE=",armeabi-v7a,armeabi"
$SUDO sed -i "/^ro.product.cpu.abilist=x86_64,x86/ s/$/${ARM_TYPE}/" ./squashfs-root/system/build.prop
$SUDO sed -i "/^ro.product.cpu.abilist32=x86/ s/$/${ARM_TYPE}/" ./squashfs-root/system/build.prop

$SUDO echo "persist.sys.nativebridge=1" >> ./squashfs-root/system/build.prop

# enable opengles
$SUDO echo "ro.opengles.version=131072" >> ./squashfs-root/system/build.prop

#squash img
cd "$WORKDIR"
rm android.img
$SUDO $MKSQUASHFS squashfs-root android.img -b 131072 -comp xz -Xbcj x86

# update anbox image
cd /var/lib/anbox
mv android.img android_bkup.img
mv "$WORKDIR/android.img" android.img 
sudo rm -rf $WORKDIR

}

BUILD(){

xterm -e XTERM

}

DOWNLOAD(){

xdg-open https://apk-get.com

}

INSTALL(){

yad --center --width=250 --height=100 --form --separator='' --title="$SELECT" --save --field="":FL > /home/$USER/apk-file.txt
adb install "$(sed '1q;d' /home/$USER/apk-file.txt)" &>/home/$USER/apk-log.txt
Notice2
rm -f /home/$USER/apk-file.txt
rm -f /home/$USER/apk-log.txt

}

Notice()
{

yad --center --width=150 --height=30 --skip-taskbar --undecorated --no-buttons --form --timeout="1" --text-align=center \
--text="$NOTICE" \

}

Notice2()
{

yad --center --width=550 --skip-taskbar --undecorated --no-buttons --selectable-labels --timeout-indicator=left --form --timeout="5" --text-align=center \
--text="$(sed '1q;d' /home/$USER/apk-log.txt)" \

}

export -f XTERM PLAYSTORE BUILD DOWNLOAD INSTALL Notice Notice2

yad  --title "Anbox" --form --height=100 --width=300 --center \
--text="$TEXT" --text-align=center \
--field="$BUILD Anbox:fbtn" '@bash -c "BUILD"' \
--field="$DOWNLOAD Apps:fbtn" '@bash -c "DOWNLOAD"' \
--field="$INSTALL Apps:fbtn" '@bash -c "INSTALL"' \
--button=gtk-quit:1 \
